#include <tuple>
#include <string>
#include <iostream>

using namespace std;

enum class Genre { Rock, Pop, Metal, Classic, Folk, Punk };

tuple<string, string, string, int, Genre> getCurrentSongInformation()
{
    return make_tuple("Dropkick Murphys", "Blackout", "Fields of Athenny", 264, Genre::Punk);
}

void printCurrentSong()
{
    string artist, album, title;
    int length;
    tie(artist, album, title, length, ignore) = getCurrentSongInformation();
    cout << artist << ": " << album << ", " << title << " - " << length << " seconds" << endl;

    // Just to demonstrate get<>()
    auto tpl = getCurrentSongInformation();
    cout << "Song: " << get<2>(tpl) << endl;
}

int main()
{
    printCurrentSong();

    return 0;
}
