#include <algorithm>
#include <cassert>
#include <vector>
#include <string>
#include <type_traits>

using namespace std;

struct Circle
{
    explicit Circle(int radius)
        : radius{radius}
    {}

    int radius;
};

struct BoundingBox
{
    int width;
    int height;
};

BoundingBox calculateBoundingBox(const Circle &circle)
{
    return {circle.radius * 2, circle.radius * 2};
}

// Just a little wrapper around stoi() to have a function that takes exactly one argument.
// An alternative would be to use a lambda or std::bind().
int stringToInt(const string &input)
{
    return stoi(input, 0, 10);
}

template<class InputType, class Func>
auto transformContainer(const vector<InputType> &input, Func func)
    -> void
{
    // TODO: Implement this function
    //
    // Change the return type from 'void' to a vector which holds the type that
    // 'func' returns. Hint: decltype will be useful here.
    //
    // Iterate over the input container, calling 'func' on each element, and add
    // the result to the container that will be returned.
}

int main()
{
    vector<Circle> circles;
    circles.push_back(Circle{12});
    circles.push_back(Circle{42});

    vector<string> strings;
    strings.push_back("12");
    strings.push_back("42");
    strings.push_back("129");

    //
    // TODO: Comment this code in as a test case for your changes
    //

    /*const vector<BoundingBox> boundingBoxes
            = transformContainer(circles, calculateBoundingBox);
    assert(boundingBoxes.size() == circles.size());
    assert(boundingBoxes[0].width == circles[0].radius * 2);
    assert(boundingBoxes[0].height == circles[0].radius * 2);
    assert(boundingBoxes[1].width == circles[1].radius * 2);
    assert(boundingBoxes[1].height == circles[1].radius * 2);

    const vector<int> numbers
            = transformContainer(strings, stringToInt);
    assert(numbers.size() == 3);
    assert(numbers[0] == 12);
    assert(numbers[1] == 42);
    assert(numbers[2] == 129);*/
}
