#include "Sensor.h"
#include "SensorData.h"

#include <cstdlib>
#include <memory>

Sensor::Sensor()
{
}

std::shared_ptr<SensorData> Sensor::fetchNext()
{
    static int timeCounter = 0;
    timeCounter++;

    auto sensorData = std::make_shared<SensorData>(timeCounter,
                                                   (std::rand() % 10) + 32);

    return sensorData;
}
