
if (MSVC)
  # no flag needed for C++11 in MSVC
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

  if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    # Make sure to link against libc++ from clang, not libstdc++ from GCC.
    # libc++ is more complete, and trying to use libstdc++ with clang gives me an
    # error:
    #     cstdio:119:11: error: no member named 'gets' in the global namespace

     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
     set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
  endif()
endif()
