#include <iostream>
#include <vector>
#include <algorithm>

static const std::vector<int> fib = {0, 1, 1, 2, 3, 5, 8, 13, 21};

int main() {

  for ( auto i : fib )
     std::cout << i << std::endl;

  std::for_each( std::begin(fib), std::end(fib),
                 [](int i) { std::cout << i << std::endl; } );

  return 0;
}
